package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.user.bo.UserStudyRecordPhotoAddBo;
import com.zhongzheng.modules.user.bo.UserStudyRecordPhotoQueryBo;
import com.zhongzheng.modules.user.bo.UserStudyRecordPhotoEditBo;
import com.zhongzheng.modules.user.domain.UserStudyRecordPhoto;
import com.zhongzheng.modules.user.mapper.UserStudyRecordPhotoMapper;
import com.zhongzheng.modules.user.vo.UserStudyRecordPhotoVo;
import com.zhongzheng.modules.user.service.IUserStudyRecordPhotoService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 学习拍摄照片Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-30
 */
@Service
public class UserStudyRecordPhotoServiceImpl extends ServiceImpl<UserStudyRecordPhotoMapper, UserStudyRecordPhoto> implements IUserStudyRecordPhotoService {

    @Override
    public UserStudyRecordPhotoVo queryById(Long recordId){
        UserStudyRecordPhoto db = this.baseMapper.selectById(recordId);
        return BeanUtil.toBean(db, UserStudyRecordPhotoVo.class);
    }

    @Override
    public List<UserStudyRecordPhotoVo> queryList(UserStudyRecordPhotoQueryBo bo) {
        LambdaQueryWrapper<UserStudyRecordPhoto> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getPhoto()), UserStudyRecordPhoto::getPhoto, bo.getPhoto());
        lqw.eq(bo.getPeriodId() != null, UserStudyRecordPhoto::getPeriodId, bo.getPeriodId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserStudyRecordPhotoVo> entity2Vo(Collection<UserStudyRecordPhoto> collection) {
        List<UserStudyRecordPhotoVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserStudyRecordPhotoVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserStudyRecordPhoto> page = (Page<UserStudyRecordPhoto>)collection;
            Page<UserStudyRecordPhotoVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserStudyRecordPhotoAddBo bo) {
        UserStudyRecordPhoto add = BeanUtil.toBean(bo, UserStudyRecordPhoto.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserStudyRecordPhotoEditBo bo) {
        UserStudyRecordPhoto update = BeanUtil.toBean(bo, UserStudyRecordPhoto.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserStudyRecordPhoto entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
